diff --git a/packaging/build-bundle.sh b/packaging/build-bundle.sh
new file mode 100755
index 000000000..0e892ed7d
--- /dev/null
+++ b/packaging/build-bundle.sh
@@ -0,0 +1,144 @@
+#!/usr/bin/env bash
+#
+# packaging/build-bundle.sh — build one portable hive release bundle.
+#
+# Produces a self-contained tarball (vendored Ruby + app + bundled gems +
+# launcher shim). This is the DECIDED distribution format (see
+# packaging/README.md): a single-file packer (Tebako / ruby-packer) was
+# time-boxed and rejected because hive's TUI depends on bubbletea/lipgloss,
+# which are FFI bindings to platform-specific prebuilt Go static libraries —
+# exactly the shape single-file packers handle worst. A portable directory
+# bundle sidesteps the problem entirely and still needs no system Ruby.
+#
+# Usage:
+#   packaging/build-bundle.sh [OUTPUT_DIR]     # default: dist
+#
+# Environment:
+#   HIVE_BUILD_VERSION   override version string (default: derived from git)
+#   HIVE_VENDORED_RUBY   path to an already-built Ruby prefix to reuse
+#                        (skips the ruby-build compile step)
+#
+# Requirements on the build host:
+#   * ruby-build (https://github.com/rbenv/ruby-build) on PATH, OR
+#     HIVE_VENDORED_RUBY pointing at a Ruby built for this platform
+#   * bundler (any recent Ruby works to drive `bundle install`; the
+#     resulting vendor/bundle is consumed by the vendored Ruby)
+#   * tar, gzip, sha256sum (shasum on macOS is handled transparently)
+
+set -euo pipefail
+
+APP_ROOT="$(cd "$(dirname "${BASH_SOURCE[0]}")/.." && pwd)"
+OUT_DIR="${1:-$APP_ROOT/dist}"
+
+log() { printf '[build-bundle] %s\n' "$*"; }
+die() { printf '[build-bundle] ERROR: %s\n' "$*" >&2; exit 1; }
+
+# ── version ───────────────────────────────────────────────────────────────
+if [[ -n "${HIVE_BUILD_VERSION:-}" ]]; then
+  VERSION="$HIVE_BUILD_VERSION"
+else
+  VERSION="$(git -C "$APP_ROOT" describe --tags --exact-match 2>/dev/null ||
+             git -C "$APP_ROOT" rev-parse --short HEAD)" || die "cannot derive version"
+fi
+VERSION="${VERSION#v}"
+
+# ── platform triple ───────────────────────────────────────────────────────
+OS="$(uname -s)"
+ARCH="$(uname -m)"
+case "$OS:$ARCH" in
+  Darwin:arm64)  PLATFORM="macos-arm64" ;;
+  Darwin:x86_64) PLATFORM="macos-x86_64" ;;
+  Linux:x86_64)  PLATFORM="linux-x86_64-gnu" ;;   # built on oldest tier-1 glibc
+  *) die "unsupported platform: $OS:$ARCH (tier-3, see packaging/README.md)" ;;
+esac
+
+STAGE_NAME="hive-${VERSION}-${PLATFORM}"
+STAGE="$OUT_DIR/$STAGE_NAME"
+rm -rf "$STAGE"
+mkdir -p "$STAGE"
+
+log "building $STAGE_NAME"
+
+# ── application tree ──────────────────────────────────────────────────────
+for item in lib bin templates schemas config Gemfile Gemfile.lock .ruby-version LICENSE README.md; do
+  if [[ -e "$APP_ROOT/$item" ]]; then
+    cp -R "$APP_ROOT/$item" "$STAGE/"
+  fi
+done
+
+# Bundle marker consumed by Hive::Channel (update/uninstall channel
+# detection) — authoritative "this came from install.sh/a Release".
+printf '%s\n' "$VERSION" > "$STAGE/.hive-bundle"
+
+# ── vendored Ruby ─────────────────────────────────────────────────────────
+RUBY_VERSION="$(tr -d '[:space:]' < "$APP_ROOT/.ruby-version")"
+VENDORED="$STAGE/opt/ruby"
+
+if [[ -n "${HIVE_VENDORED_RUBY:-}" ]]; then
+  log "reusing vendored Ruby from HIVE_VENDORED_RUBY=$HIVE_VENDORED_RUBY"
+  mkdir -p "$STAGE/opt"
+  cp -R "$HIVE_VENDORED_RUBY/" "$VENDORED/"
+elif command -v ruby-build >/dev/null 2>&1; then
+  log "compiling Ruby $RUBY_VERSION via ruby-build (this takes several minutes)"
+  ruby-build "$RUBY_VERSION" "$VENDORED"
+else
+  die "no Ruby source available: install ruby-build or set HIVE_VENDORED_RUBY"
+fi
+
+RUBY_BIN="$VENDORED/bin/ruby"
+[[ -x "$RUBY_BIN" ]] || die "vendored Ruby missing at $RUBY_BIN"
+
+# ── bundled gems ──────────────────────────────────────────────────────────
+log "vendoring gems (excluding development/test groups)"
+(
+  cd "$STAGE"
+  export PATH="$VENDORED/bin:$PATH"
+  gem install bundler --no-document
+  bundle config set --local path vendor/bundle
+  bundle config set --local without "development test"
+  bundle config set --local frozen true
+  bundle install
+) || die "bundle install failed"
+
+# ── launcher shim ─────────────────────────────────────────────────────────
+# Symlink-safe: resolves $BASH_SOURCE through any number of symlinks so the
+# same shim works when linked from ~/.local/bin/hive, Homebrew's bin/, or
+# invoked directly inside the bundle.
+cat > "$STAGE/hive" <<'SHIM'
+#!/usr/bin/env bash
+set -euo pipefail
+SOURCE="${BASH_SOURCE[0]}"
+while [ -L "$SOURCE" ]; do
+  DIR="$(cd -P "$(dirname "$SOURCE")" && pwd)"
+  SOURCE="$(readlink "$SOURCE")"
+  case "$SOURCE" in /*) ;; *) SOURCE="$DIR/$SOURCE" ;; esac
+done
+BUNDLE_ROOT="$(cd -P "$(dirname "$SOURCE")" && pwd)"
+export BUNDLE_GEMFILE="$BUNDLE_ROOT/Gemfile"
+export RUBYOPT="-rbundler/setup"
+exec "$BUNDLE_ROOT/opt/ruby/bin/ruby" "$BUNDLE_ROOT/bin/hive" "$@"
+SHIM
+chmod +x "$STAGE/hive"
+
+# Sanity gate: the shim must be able to print the version with a scrubbed
+# environment (proves the bundle does NOT need system Ruby or system gems).
+scrub_env=(env -i HOME="$(mktemp -d)" PATH="/usr/bin:/bin")
+if ! "${scrub_env[@]}" "$STAGE/hive" --version >/dev/null; then
+  die "smoke check failed: ./hive --version did not run in a scrubbed environment"
+fi
+log "smoke check passed: ./hive --version runs without system Ruby"
+
+# ── archive ───────────────────────────────────────────────────────────────
+mkdir -p "$OUT_DIR"
+TARBALL="$OUT_DIR/$STAGE_NAME.tar.gz"
+tar -czf "$TARBALL" -C "$OUT_DIR" "$STAGE_NAME"
+
+# ── checksum ──────────────────────────────────────────────────────────────
+if command -v sha256sum >/dev/null 2>&1; then
+  (cd "$OUT_DIR" && sha256sum "$STAGE_NAME.tar.gz" > "$STAGE_NAME.tar.gz.sha256")
+else
+  (cd "$OUT_DIR" && shasum -a 256 "$STAGE_NAME.tar.gz" > "$STAGE_NAME.tar.gz.sha256")
+fi
+
+log "built $TARBALL"
+log "checksum $TARBALL.sha256"
diff --git a/packaging/homebrew/Formula/hive.rb b/packaging/homebrew/Formula/hive.rb
new file mode 100644
index 000000000..c2986a888
--- /dev/null
+++ b/packaging/homebrew/Formula/hive.rb
@@ -0,0 +1,54 @@
+# Homebrew tap formula for hive (packaging plan U4).
+#
+# This file is the SOURCE OF TRUTH. It is mirrored into the separate tap
+# repo <org>/homebrew-hive (Formula/hive.rb) on every release — see
+# packaging/homebrew/README.md for the sync checklist. Users install with:
+#
+#   brew install <org>/hive/hive
+#
+# The formula consumes the prebuilt Release bundle (vendored Ruby inside),
+# so there is deliberately no system-Ruby dependency — the bundle is
+# self-contained by contract (see packaging/README.md).
+class Hive < Formula
+  desc "Folder-as-agent pipeline: LLM-driven task orchestration CLI"
+  homepage "https://github.com/ivankuznetsov/hive"
+  version "0.1.0"
+  license "MIT"
+
+  depends_on :macos
+
+  # Bottled-style: download the prebuilt per-arch Release bundle. Both
+  # tier-1/tier-2 macOS targets are built by .github/workflows/release.yml.
+  if Hardware::CPU.arm?
+    url "https://github.com/ivankuznetsov/hive/releases/download/v#{version}/hive-#{version}-macos-arm64.tar.gz"
+    sha256 "PLACEHOLDER-ARM64-SHA256" # filled by the release bump workflow
+  else
+    url "https://github.com/ivankuznetsov/hive/releases/download/v#{version}/hive-#{version}-macos-x86_64.tar.gz"
+    sha256 "PLACEHOLDER-X86_64-SHA256" # filled by the release bump workflow
+  end
+
+  def install
+    # The archive is the portable bundle; keep it intact inside the Cellar
+    # so opt/ruby + vendor/bundle stay relative to the shim.
+    libexec.install Dir["*"]
+    libexec.install ".hive-bundle"
+
+    # bin/hive is the symlink-safe shim; it resolves its own real path so
+    # the Homebrew symlink works unchanged.
+    bin.install libexec/"hive"
+  end
+
+  def caveats
+    <<~EOS
+      hive ships a vendored Ruby; no system Ruby is required.
+
+      If another `hive` command (e.g. Apache Hive) shadows this one after
+      install, run `brew unlink hive && brew link --overwrite hive`, or
+      invoke the binary as `#{opt_bin}/hive` directly.
+    EOS
+  end
+
+  test do
+    assert_match version.to_s, shell_output("#{bin}/hive --version")
+  end
+end
diff --git a/packaging/install.sh b/packaging/install.sh
new file mode 100755
index 000000000..a1ad6b838
--- /dev/null
+++ b/packaging/install.sh
@@ -0,0 +1,191 @@
+#!/usr/bin/env bash
+#
+# hive installer — `curl -fsSL <release-url>/install.sh | bash`
+#
+# Installs a self-contained hive bundle (vendored Ruby — no system Ruby
+# needed) under ~/.local/opt/hive/<version>/ and symlinks the launcher
+# into ~/.local/bin.
+#
+# Behaviour (packaging plan U3):
+#   * OS/arch detection with glibc presence check on Linux
+#   * downloads the latest pinned GitHub Release (or HIVE_VERSION)
+#   * verifies SHA256 against the Release's SHA256SUMS
+#   * idempotent: re-running upgrades in place
+#   * if another `hive` already owns PATH (e.g. Apache Hive), installs as
+#     `hv` instead and says so loudly
+#   * hard-fails with hints when git/bash/curl are missing; warns with
+#     hints (never auto-installs) for claude/gh/jq
+#
+# Environment overrides:
+#   HIVE_REPO      GitHub slug            (default ivankuznetsov/hive)
+#   HIVE_VERSION   version WITHOUT the v  (default: latest Release)
+#   HIVE_PREFIX    install root           (default $HOME/.local)
+
+set -euo pipefail
+
+REPO="${HIVE_REPO:-ivankuznetsov/hive}"
+PREFIX="${HIVE_PREFIX:-$HOME/.local}"
+INSTALL_ROOT="$PREFIX/opt/hive"
+BIN_DIR="$PREFIX/bin"
+
+log()  { printf '[hive-installer] %s\n' "$*"; }
+warn() { printf '[hive-installer] WARNING: %s\n' "$*" >&2; }
+die()  { printf '[hive-installer] ERROR: %s\n' "$*" >&2; exit 1; }
+
+have() { command -v "$1" >/dev/null 2>&1; }
+
+
+# Resolve a command path through symlinks (portable readlink -f).
+resolve_path() {
+  local target="$1"
+  if [[ "$(uname -s)" != "Darwin" ]] && have readlink && readlink -f / >/dev/null 2>&1; then
+    readlink -f "$target"
+    return
+  fi
+  local source="$target"
+  while [[ -L "$source" ]]; do
+    local dir
+    dir="$(cd -P "$(dirname "$source")" && pwd)"
+    source="$(readlink "$source")"
+    case "$source" in /*) ;; *) source="$dir/$source" ;; esac
+  done
+  printf '%s\n' "$source"
+}
+
+install_hint() {
+  local tool="$1"
+  if [[ "$(uname -s)" == "Darwin" ]]; then
+    case "$tool" in
+      git) echo "brew install git" ;;
+      bash) echo "brew install bash" ;;
+      curl) echo "brew install curl" ;;
+      tar) echo "tar ships with macOS" ;;
+      claude) echo "npm install -g @anthropic-ai/claude-code" ;;
+      gh) echo "brew install gh" ;;
+      jq) echo "brew install jq" ;;
+      *) echo "install '$tool' with your package manager" ;;
+    esac
+  elif [[ -f /etc/arch-release ]]; then
+    case "$tool" in
+      git|curl|tar|jq) echo "sudo pacman -S $tool" ;;
+      bash) echo "bash ships with Arch" ;;
+      gh) echo "sudo pacman -S github-cli" ;;
+      claude) echo "npm install -g @anthropic-ai/claude-code" ;;
+      *) echo "install '$tool' with pacman" ;;
+    esac
+  else
+    case "$tool" in
+      git|curl|jq) echo "sudo apt-get install -y $tool" ;;
+      bash) echo "bash ships with this distro" ;;
+      tar) echo "tar ships with this distro" ;;
+      gh) echo "see https://github.com/cli/cli#installation" ;;
+      claude) echo "npm install -g @anthropic-ai/claude-code" ;;
+      *) echo "install '$tool' with your package manager" ;;
+    esac
+  fi
+}
+
+# ── dependency check ──────────────────────────────────────────────────────
+for tool in curl bash git tar; do
+  have "$tool" || die "missing required tool '$tool'. Install it first, e.g.: $(install_hint "$tool")"
+done
+
+warn_optional() {
+  local tool="$1"
+  have "$tool" && return 0
+  warn "'$tool' is recommended but not installed — some features will not work."
+  warn "  hint: $(install_hint "$tool")  (hive does NOT auto-install tools)"
+}
+
+warn_optional claude
+warn_optional gh
+warn_optional jq
+
+# ── platform detection ────────────────────────────────────────────────────
+OS="$(uname -s)"
+ARCH="$(uname -m)"
+case "$OS:$ARCH" in
+  Darwin:arm64)  PLATFORM="macos-arm64" ;;
+  Darwin:x86_64) PLATFORM="macos-x86_64" ;;
+  Linux:x86_64)  PLATFORM="linux-x86_64-gnu"
+                 # glibc presence sanity (Alpine/musl is tier-3: unsupported).
+                 if ! have ldd; then
+                   die "linux-x86_64-gnu builds require glibc (ldd not found). Alpine/musl is not supported (tier-3)."
+                 fi ;;
+  *) die "unsupported platform $OS:$ARCH. Supported: macOS arm64/x86_64, Linux x86_64 (glibc). See README tier table." ;;
+esac
+
+# ── resolve version ───────────────────────────────────────────────────────
+if [[ -n "${HIVE_VERSION:-}" ]]; then
+  VERSION="${HIVE_VERSION#v}"
+else
+  log "resolving latest release..."
+  VERSION="$(curl -fsSL "https://api.github.com/repos/$REPO/releases/latest" |
+             sed -n 's/.*"tag_name": *"\([^"]*\)".*/\1/p' | head -n1)"
+  [[ -n "$VERSION" ]] || die "could not resolve latest release tag from github.com/$REPO"
+  VERSION="${VERSION#v}"
+fi
+
+TARBALL="hive-${VERSION}-${PLATFORM}.tar.gz"
+BASE_URL="https://github.com/$REPO/releases/download/v${VERSION}"
+
+TMP_DIR="$(mktemp -d)"
+trap 'rm -rf "$TMP_DIR"' EXIT
+
+# ── download + verify ─────────────────────────────────────────────────────
+log "downloading $TARBALL"
+curl -fsSL -o "$TMP_DIR/$TARBALL" "$BASE_URL/$TARBALL"
+
+log "verifying SHA256 against the Release checksums"
+curl -fsSL -o "$TMP_DIR/SHA256SUMS" "$BASE_URL/SHA256SUMS"
+(
+  cd "$TMP_DIR"
+  grep " $TARBALL\$" SHA256SUMS > .expected || die "no checksum entry for $TARBALL in SHA256SUMS"
+  if have sha256sum; then
+    sha256sum -c .expected
+  else
+    shasum -a 256 -c .expected
+  fi
+) || die "checksum verification FAILED — refusing to install"
+
+# ── install bundle ────────────────────────────────────────────────────────
+EXTRACT_DIR="$TMP_DIR/hive-${VERSION}-${PLATFORM}"
+mkdir -p "$INSTALL_ROOT" "$BIN_DIR"
+tar -xzf "$TMP_DIR/$TARBALL" -C "$TMP_DIR"
+[[ -x "$EXTRACT_DIR/hive" ]] || die "downloaded bundle is malformed (no ./hive launcher)"
+
+log "installing to $INSTALL_ROOT/$VERSION"
+rm -rf "$INSTALL_ROOT/$VERSION"
+mv "$EXTRACT_DIR" "$INSTALL_ROOT/$VERSION"
+ln -sfn "$INSTALL_ROOT/$VERSION" "$INSTALL_ROOT/current"
+
+# ── launcher symlink (+ hv collision fallback) ────────────────────────────
+LINK_NAME="hive"
+existing="$(command -v hive 2>/dev/null || true)"
+if [[ -n "$existing" ]]; then
+  resolved="$(resolve_path "$existing")"
+  case "$resolved" in
+    "$INSTALL_ROOT"/*) : ;; # our own previous install — upgrade in place
+    *)
+      LINK_NAME="hv"
+      warn "a different 'hive' command already exists at $existing"
+      warn "(Apache Hive? something else?) — installing as 'hv' instead."
+      warn "Run 'hv --version'; use 'hv' wherever docs say 'hive'."
+      ;;
+  esac
+fi
+ln -sfn "$INSTALL_ROOT/current/hive" "$BIN_DIR/$LINK_NAME"
+
+# ── PATH notice ───────────────────────────────────────────────────────────
+case ":$PATH:" in
+  *":$BIN_DIR:"*) : ;;
+  *) warn "$BIN_DIR is not on your PATH."
+     warn "  Add it:  echo 'export PATH=\"$BIN_DIR:\$PATH\"' >> ~/.bashrc  (or your shell profile)" ;;
+esac
+
+log "installed hive $VERSION as '$LINK_NAME'"
+"$BIN_DIR/$LINK_NAME" --version && log "verification passed: hive --version OK"
+log "next steps:"
+log "  cd into a project and run: $LINK_NAME init"
+
+exit 0
diff --git a/test/test_helper.rb b/test/test_helper.rb
index d251d52bf..461e5eb10 100644
--- a/test/test_helper.rb
+++ b/test/test_helper.rb
@@ -16,6 +16,10 @@ module HiveTestStdinIsolation
   def before_setup
     @hive_original_stdin = $stdin
     $stdin = StringIO.new
+    # Service registration (packaging plan U6) must never fire from tests:
+    # `hive init` integration runs would otherwise write a real launchd /
+    # systemd user unit into the developer's HOME on TTY-less machines.
+    ENV["HIVE_SKIP_SERVICE_REGISTRATION"] = "1"
     super
   end
 
diff --git a/test/unit/commands/doctor_test.rb b/test/unit/commands/doctor_test.rb
index e54f4fd5f..2b354b8e3 100644
--- a/test/unit/commands/doctor_test.rb
+++ b/test/unit/commands/doctor_test.rb
@@ -142,10 +142,12 @@ class HiveCommandsDoctorTest < Minitest::Test
 
       env = JSON.parse(out.string)
       assert_equal "hive-doctor.v1", env["schema"]
-      assert_equal 2, env["checks"].length
+      # 2 stage rows + 6 install-dependency rows (U10 install-awareness).
+      assert_equal 8, env["checks"].length
       assert_equal 1, env["summary"]["missing"]
-      assert_equal 1, env["summary"]["present"]
-      assert(env["checks"].any? { |c| c["stage"] == "plan" && c["status"] == "present" })
+      # present: 1 skill row + however many dependency probes resolve on
+      # this machine — assert the skill row via stage filter instead.
+      assert_equal 1, env["checks"].count { |c| c["stage"] == "plan" && c["status"] == "present" }
       assert(env["checks"].any? { |c| c["stage"] == "brainstorm" && c["status"] == "missing" })
     end
   end
@@ -497,7 +499,8 @@ class HiveCommandsDoctorTest < Minitest::Test
 
       env = JSON.parse(out.string)
       assert_equal "hive-doctor.v1", env["schema"]
-      assert_equal 3, env["checks"].length
+      # 2 stage + 1 reviewer + 6 dependency rows (U10 install-awareness).
+      assert_equal 9, env["checks"].length
 
       stage_entries = env["checks"].select { |c| c["kind"] == "stage" }
       reviewer_entries = env["checks"].select { |c| c["kind"] == "reviewer" }
diff --git a/test/unit/commands/uninstall_test.rb b/test/unit/commands/uninstall_test.rb
new file mode 100644
index 000000000..ec53dc496
--- /dev/null
+++ b/test/unit/commands/uninstall_test.rb
@@ -0,0 +1,300 @@
+require "test_helper"
+require "hive/commands/uninstall"
+require "hive/service"
+
+# U8 of the packaging plan: `hive uninstall` — clean removal that can
+# never destroy user work. Project state is opt-in only; --purge in
+# non-TTY never deletes .hive-state; double-uninstall is idempotent.
+class UninstallTest < Minitest::Test
+  include HiveTestHelper
+
+  FakeStatus = Class.new do
+    def initialize(success) = @success = success
+    def success? = @success
+  end
+
+  # Probe commands (pacman -Qo / sh command -v) report "not found" so
+  # channel detection stays deterministic; everything else "succeeds".
+  def ok_runner
+    ->(argv) do
+      probe = argv.first == "pacman" || argv.first == "sh"
+      [ "", "", FakeStatus.new(!probe) ]
+    end
+  end
+
+  # Real subprocess runner — needed by cleanup tests so git actually
+  # removes worktrees/branches on disk.
+  def real_runner
+    ->(argv) { Open3.capture3(*argv) }
+  end
+
+  def non_tty_stdin
+    StringIO.new
+  end
+
+  def tty_stdin(content = "")
+    io = StringIO.new(content)
+    def io.tty? = true
+    io
+  end
+
+  def with_registered_project
+    with_tmp_git_repo do |dir|
+      with_tmp_global_config do |_home|
+        Hive::Config.register_project(name: File.basename(dir), path: dir)
+        yield dir
+      end
+    end
+  end
+
+  # ── default: project work is preserved ────────────────────────────────
+
+  def test_default_uninstall_preserves_worktree_branch_and_logs
+    with_registered_project do |dir|
+      # Simulate a completed task: state worktree + branch + logs exist.
+      state = File.join(dir, ".hive-state")
+      FileUtils.mkdir_p(File.join(state, "logs"))
+      File.write(File.join(state, "logs", "task.log"), "output\n")
+      run!("git", "-C", dir, "symbolic-ref", "HEAD", "refs/heads/hive/state")
+      run!("git", "-C", dir, "commit", "--allow-empty", "-m", "state", "--quiet")
+      run!("git", "-C", dir, "symbolic-ref", "HEAD", "refs/heads/master")
+      run!("git", "-C", dir, "worktree", "add", "--quiet", ".hive-state", "hive/state") rescue nil
+
+      out = StringIO.new
+      result = Hive::Commands::Uninstall.new(
+        bin_path: "/usr/local/bin/hive", runner: ok_runner,
+        output: out, input: non_tty_stdin
+      ).call
+
+      assert_equal 0, result
+      assert File.directory?(state), "non-TTY uninstall must never delete project state"
+      assert File.exist?(File.join(state, "logs", "task.log"))
+      refute_empty run!("git", "-C", dir, "branch", "--list", "hive/state").strip,
+                   "hive/state branch must survive default uninstall"
+      # Registry entry untouched (project still registered).
+      refute_empty Hive::Config.registered_projects
+    end
+  end
+
+  # ── opt-in cleanup removes exactly the project's hive content ─────────
+
+  def test_opt_in_cleanup_removes_registered_project_hive_content
+    with_registered_project do |dir|
+      state = File.join(dir, ".hive-state")
+      FileUtils.mkdir_p(state)
+
+      out = StringIO.new
+      result = Hive::Commands::Uninstall.new(
+        bin_path: "/usr/local/bin/hive", runner: ok_runner,
+        output: out, input: non_tty_stdin, runner: real_runner,
+        cleanup_projects: [ File.basename(dir) ] # explicit opt-in
+      ).call
+
+      assert_equal 0, result
+      refute File.exist?(state), "opted-in project's .hive-state must be removed"
+      assert_empty run!("git", "-C", dir, "branch", "--list", "hive/state").strip,
+                   "hive/state branch must be deleted on opt-in cleanup"
+      assert_empty Hive::Config.registered_projects,
+                   "registry entry must be dropped on opt-in cleanup"
+      assert File.exist?(File.join(dir, "README.md")), "project files must survive"
+    end
+  end
+
+  def test_opt_in_cleanup_is_scoped_to_named_projects_only
+    with_registered_project do |dir|
+      # A second registered project that must stay untouched.
+      other = File.expand_path(File.join(dir, "..", "other-project"))
+      FileUtils.mkdir_p(File.join(dir, ".hive-state"))
+      FileUtils.mkdir_p(File.join(other, ".hive-state"))
+      Hive::Config.register_project(name: "other-project", path: other)
+
+      out = StringIO.new
+      Hive::Commands::Uninstall.new(
+        bin_path: "/usr/local/bin/hive", runner: ok_runner,
+        output: out, input: non_tty_stdin, runner: real_runner,
+        cleanup_projects: [ "other-project" ]
+      ).call
+
+      assert File.directory?(File.join(dir, ".hive-state")),
+             "non-opted project's state must survive"
+      refute File.directory?(File.join(other, ".hive-state")),
+             "opted project's state must be removed"
+    end
+  end
+
+  # ── --purge non-TTY never deletes project state ───────────────────────
+
+  def test_purge_non_tty_does_not_delete_state
+    with_registered_project do |dir|
+      state = File.join(dir, ".hive-state")
+      FileUtils.mkdir_p(state)
+
+      out = StringIO.new
+      result = Hive::Commands::Uninstall.new(
+        bin_path: "/usr/local/bin/hive", runner: ok_runner,
+        output: out, input: non_tty_stdin, purge: true
+      ).call
+
+      assert_equal 0, result
+      assert File.directory?(state),
+             "--purge in non-TTY must not delete project state (purge is non-interactivity, not deletion)"
+    end
+  end
+
+  # ── interactive prompts ───────────────────────────────────────────────
+
+  def test_interactive_prompt_default_answer_declines_cleanup
+    with_registered_project do |dir|
+      state = File.join(dir, ".hive-state")
+      FileUtils.mkdir_p(state)
+
+      out = StringIO.new
+      Hive::Commands::Uninstall.new(
+        bin_path: "/usr/local/bin/hive", runner: ok_runner,
+        output: out, input: tty_stdin("\n") # bare Enter → default N
+      ).call
+
+      assert File.directory?(state), "default prompt answer must decline cleanup"
+    end
+  end
+
+  def test_interactive_prompt_yes_removes_state
+    with_registered_project do |dir|
+      state = File.join(dir, ".hive-state")
+      FileUtils.mkdir_p(state)
+
+      out = StringIO.new
+      Hive::Commands::Uninstall.new(
+        bin_path: "/usr/local/bin/hive", runner: ok_runner,
+        output: out, input: tty_stdin("y\n"), runner: real_runner
+      ).call
+
+      refute File.directory?(state), "explicit 'y' must remove opted-in project state"
+    end
+  end
+
+  # ── channel layer ─────────────────────────────────────────────────────
+
+  def test_brew_channel_prints_exact_native_removal_line
+    out = StringIO.new
+    Hive::Commands::Uninstall.new(
+      bin_path: "/opt/homebrew/Cellar/hive/0.1.0/bin/hive", runner: ok_runner,
+      output: out, input: non_tty_stdin
+    ).call
+
+    assert_includes out.string, "brew uninstall hive"
+  end
+
+  def test_pacman_channel_prints_exact_native_removal_line
+    pacman = ->(argv) { argv; [ "", "", FakeStatus.new(true) ] }
+    out = StringIO.new
+    Hive::Commands::Uninstall.new(
+      bin_path: "/usr/bin/hive", runner: pacman,
+      output: out, input: non_tty_stdin
+    ).call
+
+    assert_includes out.string, "sudo pacman -Rns hive-bin"
+  end
+
+  def test_script_channel_removes_bundle_and_symlinks
+    with_tmp_dir do |home|
+      old_home = ENV["HOME"]
+      ENV["HOME"] = home
+      begin
+        version_dir = File.join(home, ".local", "opt", "hive", "0.1.0")
+        bin_dir = File.join(version_dir, "bin")
+        FileUtils.mkdir_p(bin_dir)
+        File.write(File.join(version_dir, Hive::Channel::BUNDLE_MARKER), "0.1.0")
+        File.write(File.join(bin_dir, "hive"), "#!/bin/sh\n")
+
+        local_bin = File.join(home, ".local", "bin")
+        FileUtils.mkdir_p(local_bin)
+        File.symlink(File.join(bin_dir, "hive"), File.join(local_bin, "hive"))
+        File.symlink(File.join(bin_dir, "hive"), File.join(local_bin, "hv"))
+        # A symlink pointing elsewhere must survive.
+        File.symlink("/usr/bin/env", File.join(local_bin, "keepme"))
+
+        out = StringIO.new
+        result = Hive::Commands::Uninstall.new(
+          bin_path: File.join(bin_dir, "hive"),
+          runner: ->(argv) { argv; [ "", "", FakeStatus.new(false) ] },
+          output: out, input: non_tty_stdin
+        ).call
+
+        assert_equal 0, result
+        refute File.exist?(version_dir), "script bundle must be removed"
+        refute File.symlink?(File.join(local_bin, "hive")), "hive symlink must be removed"
+        refute File.symlink?(File.join(local_bin, "hv")), "hv fallback symlink must be removed"
+        assert File.symlink?(File.join(local_bin, "keepme")), "unrelated symlinks must survive"
+      ensure
+        ENV["HOME"] = old_home
+      end
+    end
+  end
+
+  # ── idempotency ───────────────────────────────────────────────────────
+
+  def test_double_uninstall_is_idempotent
+    out1 = StringIO.new
+    out2 = StringIO.new
+    runner = ->(argv) { argv; [ "", "", FakeStatus.new(false) ] }
+
+    2.times do |i|
+      result = Hive::Commands::Uninstall.new(
+        bin_path: "/usr/local/bin/hive", runner: runner,
+        output: i.zero? ? out1 : out2, input: non_tty_stdin
+      ).call
+      assert_equal 0, result, "uninstall must be safely re-runnable"
+    end
+  end
+
+  # ── service layer is always attempted ─────────────────────────────────
+
+  def test_service_registration_removal_is_attempted
+    calls = []
+    fake_service = Class.new do
+      c = calls
+      define_singleton_method(:skipped?) { false }
+      define_singleton_method(:remove!) { |**kw| c << kw; true }
+    end
+
+    out = StringIO.new
+    Hive::Commands::Uninstall.new(
+      bin_path: "/usr/local/bin/hive", runner: ok_runner,
+      output: out, input: non_tty_stdin, service: fake_service
+    ).call
+
+    assert_equal 1, calls.size, "uninstall must always attempt service removal"
+  end
+
+  def test_service_removal_failure_is_non_fatal
+    fake_service = Class.new do
+      define_singleton_method(:skipped?) { false }
+      define_singleton_method(:remove!) { |**_kw| raise "backend exploded" }
+    end
+
+    out = StringIO.new
+    result = Hive::Commands::Uninstall.new(
+      bin_path: "/usr/local/bin/hive", runner: ok_runner,
+      output: out, input: non_tty_stdin, service: fake_service
+    ).call
+
+    assert_equal 0, result, "service-removal failure must not abort uninstall"
+    assert_includes out.string, "warning"
+  end
+
+  def test_skip_flag_skips_service_removal
+    fake_service = Class.new do
+      define_singleton_method(:skipped?) { true }
+      define_singleton_method(:remove!) { |**_kw| raise "must not be called" }
+    end
+
+    out = StringIO.new
+    Hive::Commands::Uninstall.new(
+      bin_path: "/usr/local/bin/hive", runner: ok_runner,
+      output: out, input: non_tty_stdin, service: fake_service
+    ).call
+
+    assert true # no raise — removal skipped
+  end
+end
